diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/examples/vanet-routing-compare.cc ns-3.38/src/wave/examples/vanet-routing-compare.cc
--- ns-3.37/src/wave/examples/vanet-routing-compare.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/examples/vanet-routing-compare.cc	2023-03-16 20:54:23.844869400 -0700
@@ -144,25 +144,25 @@
      * \brief Returns the number of bytes received
      * \return the number of bytes received
      */
-    uint32_t GetRxBytes();
+    uint32_t GetRxBytes() const;
 
     /**
      * \brief Returns the cumulative number of bytes received
      * \return the cumulative number of bytes received
      */
-    uint32_t GetCumulativeRxBytes();
+    uint32_t GetCumulativeRxBytes() const;
 
     /**
      * \brief Returns the count of packets received
      * \return the count of packets received
      */
-    uint32_t GetRxPkts();
+    uint32_t GetRxPkts() const;
 
     /**
      * \brief Returns the cumulative count of packets received
      * \return the cumulative count of packets received
      */
-    uint32_t GetCumulativeRxPkts();
+    uint32_t GetCumulativeRxPkts() const;
 
     /**
      * \brief Increments the number of (application-data)
@@ -192,25 +192,25 @@
      * \brief Returns the number of bytes transmitted
      * \return the number of bytes transmitted
      */
-    uint32_t GetTxBytes();
+    uint32_t GetTxBytes() const;
 
     /**
      * \brief Returns the cumulative number of bytes transmitted
      * \return the cumulative number of bytes transmitted
      */
-    uint32_t GetCumulativeTxBytes();
+    uint32_t GetCumulativeTxBytes() const;
 
     /**
      * \brief Returns the number of packets transmitted
      * \return the number of packets transmitted
      */
-    uint32_t GetTxPkts();
+    uint32_t GetTxPkts() const;
 
     /**
      * \brief Returns the cumulative number of packets transmitted
      * \return the cumulative number of packets transmitted
      */
-    uint32_t GetCumulativeTxPkts();
+    uint32_t GetCumulativeTxPkts() const;
 
     /**
      * \brief Increment the number of bytes transmitted
@@ -236,7 +236,7 @@
     void SetTxPkts(uint32_t txPkts);
 
   private:
-    uint32_t m_RxBytes;           ///< reeive bytes
+    uint32_t m_RxBytes;           ///< receive bytes
     uint32_t m_cumulativeRxBytes; ///< cumulative receive bytes
     uint32_t m_RxPkts;            ///< receive packets
     uint32_t m_cumulativeRxPkts;  ///< cumulative receive packets
@@ -259,25 +259,25 @@
 }
 
 uint32_t
-RoutingStats::GetRxBytes()
+RoutingStats::GetRxBytes() const
 {
     return m_RxBytes;
 }
 
 uint32_t
-RoutingStats::GetCumulativeRxBytes()
+RoutingStats::GetCumulativeRxBytes() const
 {
     return m_cumulativeRxBytes;
 }
 
 uint32_t
-RoutingStats::GetRxPkts()
+RoutingStats::GetRxPkts() const
 {
     return m_RxPkts;
 }
 
 uint32_t
-RoutingStats::GetCumulativeRxPkts()
+RoutingStats::GetCumulativeRxPkts() const
 {
     return m_cumulativeRxPkts;
 }
@@ -309,25 +309,25 @@
 }
 
 uint32_t
-RoutingStats::GetTxBytes()
+RoutingStats::GetTxBytes() const
 {
     return m_TxBytes;
 }
 
 uint32_t
-RoutingStats::GetCumulativeTxBytes()
+RoutingStats::GetCumulativeTxBytes() const
 {
     return m_cumulativeTxBytes;
 }
 
 uint32_t
-RoutingStats::GetTxPkts()
+RoutingStats::GetTxPkts() const
 {
     return m_TxPkts;
 }
 
 uint32_t
-RoutingStats::GetCumulativeTxPkts()
+RoutingStats::GetCumulativeTxPkts() const
 {
     return m_cumulativeTxPkts;
 }
@@ -397,7 +397,7 @@
      * route data
      * \param protocol the routing protocol (1=OLSR;2=AODV;3=DSDV;4=DSR)
      * \param nSinks the number of nodes which will act as data sinks
-     * \param routingTables dump routing tables at t=5 seconds (0=no;1=yes)
+     * \param routingTables whether to dump routing tables at t=5 seconds
      */
     void Install(NodeContainer& c,
                  NetDeviceContainer& d,
@@ -405,7 +405,7 @@
                  double totalTime,
                  int protocol,
                  uint32_t nSinks,
-                 int routingTables);
+                 bool routingTables);
 
     /**
      * \brief Trace the receipt of an on-off-application generated packet
@@ -422,9 +422,9 @@
 
     /**
      * \brief Enable/disable logging
-     * \param log non-zero to enable logging
+     * \param log whether to enable logging
      */
-    void SetLogging(int log);
+    void SetLogging(bool log);
 
   private:
     /**
@@ -448,7 +448,7 @@
     void SetupRoutingMessages(NodeContainer& c, Ipv4InterfaceContainer& adhocTxInterfaces);
 
     /**
-     * \brief Sets up a routing packet for tranmission
+     * \brief Sets up a routing packet for transmission
      * \param addr destination address
      * \param node source node
      * \return Socket to be used for sending/receiving a routed data packet
@@ -465,10 +465,10 @@
     uint32_t m_protocol;        ///< routing protocol; 0=NONE, 1=OLSR, 2=AODV, 3=DSDV, 4=DSR
     uint32_t m_port;            ///< port
     uint32_t m_nSinks;          ///< number of sink nodes (< all nodes)
-    int m_routingTables;        ///< dump routing table (at t=5 sec).  0=No, 1=Yes
+    bool m_routingTables;       ///< dump routing table (at t=5 sec).  0=No, 1=Yes
     RoutingStats routingStats;  ///< routing statistics
     std::string m_protocolName; ///< protocol name
-    int m_log;                  ///< log
+    bool m_log;                 ///< log
 };
 
 NS_OBJECT_ENSURE_REGISTERED(RoutingHelper);
@@ -486,8 +486,8 @@
       m_protocol(0),
       m_port(9),
       m_nSinks(0),
-      m_routingTables(0),
-      m_log(0)
+      m_routingTables(false),
+      m_log(false)
 {
 }
 
@@ -502,7 +502,7 @@
                        double totalTime,
                        int protocol,
                        uint32_t nSinks,
-                       int routingTables)
+                       bool routingTables)
 {
     m_TotalSimTime = totalTime;
     m_protocol = protocol;
@@ -547,25 +547,25 @@
         m_protocolName = "NONE";
         break;
     case 1:
-        if (m_routingTables != 0)
+        if (m_routingTables)
         {
-            olsr.PrintRoutingTableAllAt(rtt, rtw);
+            Ipv4RoutingHelper::PrintRoutingTableAllAt(rtt, rtw);
         }
         list.Add(olsr, 100);
         m_protocolName = "OLSR";
         break;
     case 2:
-        if (m_routingTables != 0)
+        if (m_routingTables)
         {
-            aodv.PrintRoutingTableAllAt(rtt, rtw);
+            Ipv4RoutingHelper::PrintRoutingTableAllAt(rtt, rtw);
         }
         list.Add(aodv, 100);
         m_protocolName = "AODV";
         break;
     case 3:
-        if (m_routingTables != 0)
+        if (m_routingTables)
         {
-            dsdv.PrintRoutingTableAllAt(rtt, rtw);
+            ns3::DsdvHelper::PrintRoutingTableAllAt(rtt, rtw);
         }
         list.Add(dsdv, 100);
         m_protocolName = "DSDV";
@@ -590,7 +590,7 @@
         dsrMain.Install(dsr, c);
     }
 
-    if (m_log != 0)
+    if (m_log)
     {
         NS_LOG_UNCOND("Routing Setup for " << m_protocolName);
     }
@@ -673,7 +673,7 @@
         uint32_t RxRoutingBytes = packet->GetSize();
         GetRoutingStats().IncRxBytes(RxRoutingBytes);
         GetRoutingStats().IncRxPkts();
-        if (m_log != 0)
+        if (m_log)
         {
             NS_LOG_UNCOND(m_protocolName + " " +
                           PrintReceivedRoutingPacket(socket, packet, srcAddress));
@@ -695,7 +695,7 @@
 }
 
 void
-RoutingHelper::SetLogging(int log)
+RoutingHelper::SetLogging(bool log)
 {
     m_log = log;
 }
@@ -728,10 +728,10 @@
      * (this includes MAC/PHY overhead)
      * \return the number of bytes transmitted
      */
-    uint32_t GetTxBytes();
+    uint32_t GetTxBytes() const;
 
     /**
-     * \brief Callback signiture for Phy/Tx trace
+     * \brief Callback signature for Phy/Tx trace
      * \param context this object
      * \param packet packet transmitted
      * \param mode wifi mode
@@ -745,14 +745,14 @@
                     uint8_t txPower);
 
     /**
-     * \brief Callback signiture for Phy/TxDrop
+     * \brief Callback signature for Phy/TxDrop
      * \param context this object
      * \param packet the tx packet being dropped
      */
     void PhyTxDrop(std::string context, Ptr<const Packet> packet);
 
     /**
-     * \brief Callback signiture for Phy/RxDrop
+     * \brief Callback signature for Phy/RxDrop
      * \param context this object
      * \param packet the rx packet being dropped
      * \param reason the reason for the drop
@@ -814,7 +814,7 @@
 }
 
 uint32_t
-WifiPhyStats::GetTxBytes()
+WifiPhyStats::GetTxBytes() const
 {
     return m_phyTxBytes;
 }
@@ -1033,7 +1033,7 @@
 ConfigStoreHelper::SaveConfig(std::string configFilename)
 {
     // only save if a non-empty filename has been specified
-    if (configFilename != "")
+    if (!configFilename.empty())
     {
         // Output config store to txt format
         Config::SetDefault("ns3::ConfigStore::Filename", StringValue(configFilename));
@@ -1227,36 +1227,35 @@
     int m_nodePause;                            ///< in s
     uint32_t m_wavePacketSize;                  ///< bytes
     double m_waveInterval;                      ///< seconds
-    int m_verbose;                              ///< verbose
+    bool m_verbose;                             ///< verbose
     std::ofstream m_os;                         ///< output stream
     NetDeviceContainer m_adhocTxDevices;        ///< adhoc transmit devices
     Ipv4InterfaceContainer m_adhocTxInterfaces; ///< adhoc transmit interfaces
     uint32_t m_scenario;                        ///< scenario
     double m_gpsAccuracyNs;                     ///< GPS accuracy
     double m_txMaxDelayMs;                      ///< transmit maximum delay
-    int m_routingTables;                        ///< routing tables
-    int m_asciiTrace;                           ///< ascii trace
-    int m_pcap;                                 ///< PCAP
+    bool m_routingTables;                       ///< routing tables
+    bool m_asciiTrace;                          ///< ascii trace
+    bool m_pcap;                                ///< PCAP
     std::string m_loadConfigFilename;           ///< load config file name
-    std::string m_saveConfigFilename;           ///< save configi file name
+    std::string m_saveConfigFilename;           ///< save config file name
 
     WaveBsmHelper m_waveBsmHelper;      ///< helper
     Ptr<RoutingHelper> m_routingHelper; ///< routing helper
     Ptr<WifiPhyStats> m_wifiPhyStats;   ///< wifi phy statistics
-    int m_log;                          ///< log
-    /// used to get consistent random numbers across scenarios
-    int64_t m_streamIndex;
-    NodeContainer m_adhocTxNodes;         ///< adhoc transmit nodes
-    double m_txSafetyRange1;              ///< range 1
-    double m_txSafetyRange2;              ///< range 2
-    double m_txSafetyRange3;              ///< range 3
-    double m_txSafetyRange4;              ///< range 4
-    double m_txSafetyRange5;              ///< range 5
-    double m_txSafetyRange6;              ///< range 6
-    double m_txSafetyRange7;              ///< range 7
-    double m_txSafetyRange8;              ///< range 8
-    double m_txSafetyRange9;              ///< range 9
-    double m_txSafetyRange10;             ///< range 10
+    bool m_log;                         ///< log
+    int64_t m_streamIndex;              ///< used to get consistent random numbers across scenarios
+    NodeContainer m_adhocTxNodes;       ///< adhoc transmit nodes
+    double m_txSafetyRange1;            ///< range 1
+    double m_txSafetyRange2;            ///< range 2
+    double m_txSafetyRange3;            ///< range 3
+    double m_txSafetyRange4;            ///< range 4
+    double m_txSafetyRange5;            ///< range 5
+    double m_txSafetyRange6;            ///< range 6
+    double m_txSafetyRange7;            ///< range 7
+    double m_txSafetyRange8;            ///< range 8
+    double m_txSafetyRange9;            ///< range 9
+    double m_txSafetyRange10;           ///< range 10
     std::vector<double> m_txSafetyRanges; ///< list of ranges
     std::string m_exp;                    ///< exp
     Time m_cumulativeBsmCaptureStart;     ///< capture start
@@ -1291,16 +1290,16 @@
       m_nodePause(0),
       m_wavePacketSize(200),
       m_waveInterval(0.1),
-      m_verbose(0),
+      m_verbose(false),
       m_scenario(1),
       m_gpsAccuracyNs(40),
       m_txMaxDelayMs(10),
-      m_routingTables(0),
-      m_asciiTrace(0),
-      m_pcap(0),
+      m_routingTables(false),
+      m_asciiTrace(false),
+      m_pcap(false),
       m_loadConfigFilename("load-config.txt"),
       m_saveConfigFilename(""),
-      m_log(0),
+      m_log(false),
       m_streamIndex(0),
       m_adhocTxNodes(),
       m_txSafetyRange1(50.0),
@@ -1320,9 +1319,8 @@
     m_wifiPhyStats = CreateObject<WifiPhyStats>();
     m_routingHelper = CreateObject<RoutingHelper>();
 
-    // set to non-zero value to enable
     // simply uncond logging during simulation run
-    m_log = 1;
+    m_log = true;
 }
 
 void
@@ -1347,9 +1345,9 @@
 
 /// Trace mobility 1=yes;0=no
 static ns3::GlobalValue g_traceMobility("VRCtraceMobility",
-                                        "Trace mobility 1=yes;0=no",
-                                        ns3::UintegerValue(0),
-                                        ns3::MakeUintegerChecker<uint32_t>());
+                                        "Enable trace mobility",
+                                        ns3::BooleanValue(false),
+                                        ns3::MakeBooleanChecker());
 
 /// Routing protocol
 static ns3::GlobalValue g_protocol("VRCprotocol",
@@ -1407,9 +1405,9 @@
 
 /// Verbose 0=no;1=yes
 static ns3::GlobalValue g_verbose("VRCverbose",
-                                  "Verbose 0=no;1=yes",
-                                  ns3::UintegerValue(0),
-                                  ns3::MakeUintegerChecker<uint32_t>());
+                                  "Enable verbose",
+                                  ns3::BooleanValue(false),
+                                  ns3::MakeBooleanChecker());
 
 /// Scenario
 static ns3::GlobalValue g_scenario("VRCscenario",
@@ -1419,21 +1417,21 @@
 
 /// Dump routing tables at t=5 seconds 0=no;1=yes
 static ns3::GlobalValue g_routingTables("VRCroutingTables",
-                                        "Dump routing tables at t=5 seconds 0=no;1=yes",
-                                        ns3::UintegerValue(0),
-                                        ns3::MakeUintegerChecker<uint32_t>());
+                                        "Dump routing tables at t=5 seconds",
+                                        ns3::BooleanValue(false),
+                                        ns3::MakeBooleanChecker());
 
 /// Dump ASCII trace 0=no;1=yes
 static ns3::GlobalValue g_asciiTrace("VRCasciiTrace",
-                                     "Dump ASCII trace 0=no;1=yes",
-                                     ns3::UintegerValue(0),
-                                     ns3::MakeUintegerChecker<uint32_t>());
+                                     "Dump ASCII trace",
+                                     ns3::BooleanValue(false),
+                                     ns3::MakeBooleanChecker());
 
 /// Generate PCAP files 0=no;1=yes
 static ns3::GlobalValue g_pcap("VRCpcap",
-                               "Generate PCAP files 0=no;1=yes",
-                               ns3::UintegerValue(0),
-                               ns3::MakeUintegerChecker<uint32_t>());
+                               "Generate PCAP files",
+                               ns3::BooleanValue(false),
+                               ns3::MakeBooleanChecker());
 
 /// Simulation start time for capturing cumulative BSM
 static ns3::GlobalValue g_cumulativeBsmCaptureStart(
@@ -1732,7 +1730,7 @@
         mac_phy_oh = (double)(totalPhyBytes - totalAppBytes) / (double)totalPhyBytes;
     }
 
-    if (m_log != 0)
+    if (m_log)
     {
         NS_LOG_UNCOND("BSM_PDR1=" << bsm_pdr1 << " BSM_PDR2=" << bsm_pdr2
                                   << " BSM_PDR3=" << bsm_pdr3 << " BSM_PDR4=" << bsm_pdr4
@@ -1834,7 +1832,7 @@
 
     std::ofstream out(m_CSVfileName, std::ios::app);
 
-    if (m_log != 0)
+    if (m_log)
     {
         NS_LOG_UNCOND("At t=" << (Simulator::Now()).As(Time::S) << " BSM_PDR1=" << wavePDR1_2
                               << " BSM_PDR1=" << wavePDR2_2 << " BSM_PDR3=" << wavePDR3_2
@@ -1885,6 +1883,7 @@
     DoubleValue doubleValue;
     StringValue stringValue;
     TimeValue timeValue;
+    BooleanValue booleanValue;
 
     // This may not be the best way to manage program configuration
     // (directing them through global values), but management
@@ -1895,8 +1894,8 @@
     m_port = uintegerValue.Get();
     GlobalValue::GetValueByName("VRCnSinks", uintegerValue);
     m_nSinks = uintegerValue.Get();
-    GlobalValue::GetValueByName("VRCtraceMobility", uintegerValue);
-    m_traceMobility = uintegerValue.Get();
+    GlobalValue::GetValueByName("VRCtraceMobility", booleanValue);
+    m_traceMobility = booleanValue.Get();
     GlobalValue::GetValueByName("VRCprotocol", uintegerValue);
     m_protocol = uintegerValue.Get();
     GlobalValue::GetValueByName("VRClossModel", uintegerValue);
@@ -1915,16 +1914,16 @@
     m_nodePause = uintegerValue.Get();
     GlobalValue::GetValueByName("VRCwavePacketSize", uintegerValue);
     m_wavePacketSize = uintegerValue.Get();
-    GlobalValue::GetValueByName("VRCverbose", uintegerValue);
-    m_verbose = uintegerValue.Get();
+    GlobalValue::GetValueByName("VRCverbose", booleanValue);
+    m_verbose = booleanValue.Get();
     GlobalValue::GetValueByName("VRCscenario", uintegerValue);
     m_scenario = uintegerValue.Get();
-    GlobalValue::GetValueByName("VRCroutingTables", uintegerValue);
-    m_routingTables = uintegerValue.Get();
-    GlobalValue::GetValueByName("VRCasciiTrace", uintegerValue);
-    m_asciiTrace = uintegerValue.Get();
-    GlobalValue::GetValueByName("VRCpcap", uintegerValue);
-    m_pcap = uintegerValue.Get();
+    GlobalValue::GetValueByName("VRCroutingTables", booleanValue);
+    m_routingTables = booleanValue.Get();
+    GlobalValue::GetValueByName("VRCasciiTrace", booleanValue);
+    m_asciiTrace = booleanValue.Get();
+    GlobalValue::GetValueByName("VRCpcap", booleanValue);
+    m_pcap = booleanValue.Get();
     GlobalValue::GetValueByName("VRCcumulativeBsmCaptureStart", timeValue);
     m_cumulativeBsmCaptureStart = timeValue.Get();
 
@@ -1987,7 +1986,7 @@
 
     g_port.SetValue(UintegerValue(m_port));
     g_nSinks.SetValue(UintegerValue(m_nSinks));
-    g_traceMobility.SetValue(UintegerValue(m_traceMobility));
+    g_traceMobility.SetValue(BooleanValue(m_traceMobility));
     g_protocol.SetValue(UintegerValue(m_protocol));
     g_lossModel.SetValue(UintegerValue(m_lossModel));
     g_fading.SetValue(UintegerValue(m_fading));
@@ -1997,11 +1996,11 @@
     g_nodeSpeed.SetValue(UintegerValue(m_nodeSpeed));
     g_nodePause.SetValue(UintegerValue(m_nodePause));
     g_wavePacketSize.SetValue(UintegerValue(m_wavePacketSize));
-    g_verbose.SetValue(UintegerValue(m_verbose));
+    g_verbose.SetValue(BooleanValue(m_verbose));
     g_scenario.SetValue(UintegerValue(m_scenario));
-    g_routingTables.SetValue(UintegerValue(m_routingTables));
-    g_asciiTrace.SetValue(UintegerValue(m_asciiTrace));
-    g_pcap.SetValue(UintegerValue(m_pcap));
+    g_routingTables.SetValue(BooleanValue(m_routingTables));
+    g_asciiTrace.SetValue(BooleanValue(m_asciiTrace));
+    g_pcap.SetValue(BooleanValue(m_pcap));
     g_cumulativeBsmCaptureStart.SetValue(TimeValue(m_cumulativeBsmCaptureStart));
 
     g_txSafetyRange1.SetValue(DoubleValue(m_txSafetyRange1));
@@ -2067,7 +2066,7 @@
     cmd.AddValue("phyModeB", "Phy mode 802.11b", m_phyModeB);
     cmd.AddValue("speed", "Node speed (m/s)", m_nodeSpeed);
     cmd.AddValue("pause", "Node pause (s)", m_nodePause);
-    cmd.AddValue("verbose", "0=quiet;1=verbose", m_verbose);
+    cmd.AddValue("verbose", "Enable verbose output", m_verbose);
     cmd.AddValue("bsm", "(WAVE) BSM size (bytes)", m_wavePacketSize);
     cmd.AddValue("interval", "(WAVE) BSM interval (s)", m_waveInterval);
     cmd.AddValue("scenario", "1=synthetic, 2=playback-trace", m_scenario);
@@ -2086,9 +2085,9 @@
     cmd.AddValue("txdist10", "Expected BSM tx range, m", txDist10);
     cmd.AddValue("gpsaccuracy", "GPS time accuracy, in ns", m_gpsAccuracyNs);
     cmd.AddValue("txmaxdelay", "Tx max delay, in ms", m_txMaxDelayMs);
-    cmd.AddValue("routingTables", "Dump routing tables at t=5 seconds", m_routingTables);
-    cmd.AddValue("asciiTrace", "Dump ASCII Trace data", m_asciiTrace);
-    cmd.AddValue("pcap", "Create PCAP files for all nodes", m_pcap);
+    cmd.AddValue("routingTables", "Whether to dump routing tables at t=5 seconds", m_routingTables);
+    cmd.AddValue("asciiTrace", "Whether to dump ASCII Trace data", m_asciiTrace);
+    cmd.AddValue("pcap", "Whether to create PCAP files for all nodes", m_pcap);
     cmd.AddValue("loadconfig", "Config-store filename to load", m_loadConfigFilename);
     cmd.AddValue("saveconfig", "Config-store filename to save", m_saveConfigFilename);
     cmd.AddValue("exp", "Experiment", m_exp);
@@ -2256,7 +2255,7 @@
     wifiChannel.SetPropagationDelay("ns3::ConstantSpeedPropagationDelayModel");
     if (m_lossModel == 3)
     {
-        // two-ray requires antenna height (else defaults to Friss)
+        // two-ray requires antenna height (else defaults to Friis)
         wifiChannel.AddPropagationLoss(m_lossModelName,
                                        "Frequency",
                                        DoubleValue(freq),
@@ -2294,9 +2293,9 @@
     Wifi80211pHelper wifi80211p = Wifi80211pHelper::Default();
     if (m_verbose)
     {
-        wifi80211p.EnableLogComponents(); // Turn on all Wifi 802.11p logging
+        Wifi80211pHelper::EnableLogComponents(); // Turn on all Wifi 802.11p logging
         // likewise, turn on WAVE PHY logging
-        waveHelper.EnableLogComponents();
+        WaveHelper::EnableLogComponents();
     }
 
     WifiHelper wifi;
@@ -2350,14 +2349,14 @@
         m_adhocTxDevices = wifi.Install(wifiPhy, wifiMac, m_adhocTxNodes);
     }
 
-    if (m_asciiTrace != 0)
+    if (m_asciiTrace)
     {
         AsciiTraceHelper ascii;
         Ptr<OutputStreamWrapper> osw = ascii.CreateFileStream(m_trName + ".tr");
         wifiPhy.EnableAsciiAll(osw);
         wavePhy.EnableAsciiAll(osw);
     }
-    if (m_pcap != 0)
+    if (m_pcap)
     {
         wifiPhy.EnablePcapAll("vanet-routing-compare-pcap");
         wavePhy.EnablePcapAll("vanet-routing-compare-pcap");
@@ -2496,4 +2495,6 @@
 {
     VanetRoutingExperiment experiment;
     experiment.Simulate(argc, argv);
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/examples/wave-simple-80211p.cc ns-3.38/src/wave/examples/wave-simple-80211p.cc
--- ns-3.37/src/wave/examples/wave-simple-80211p.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/examples/wave-simple-80211p.cc	2023-03-16 20:54:23.844869400 -0700
@@ -146,7 +146,7 @@
     Wifi80211pHelper wifi80211p = Wifi80211pHelper::Default();
     if (verbose)
     {
-        wifi80211p.EnableLogComponents(); // Turn on all Wifi 802.11p logging
+        Wifi80211pHelper::EnableLogComponents(); // Turn on all Wifi 802.11p logging
     }
 
     wifi80211p.SetRemoteStationManager("ns3::ConstantRateWifiManager",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/helper/wave-bsm-stats.cc ns-3.38/src/wave/helper/wave-bsm-stats.cc
--- ns-3.37/src/wave/helper/wave-bsm-stats.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/helper/wave-bsm-stats.cc	2023-03-16 20:54:23.844869400 -0700
@@ -32,7 +32,7 @@
     : m_wavePktSendCount(0),
       m_waveByteSendCount(0),
       m_wavePktReceiveCount(0),
-      m_log(0)
+      m_log(false)
 {
     m_wavePktExpectedReceiveCounts.resize(10, 0);
     m_wavePktInCoverageReceiveCounts.resize(10, 0);
@@ -58,7 +58,7 @@
 }
 
 int
-WaveBsmStats::GetTxPktCount()
+WaveBsmStats::GetTxPktCount() const
 {
     return m_wavePktSendCount;
 }
@@ -84,7 +84,7 @@
 }
 
 int
-WaveBsmStats::GetRxPktCount()
+WaveBsmStats::GetRxPktCount() const
 {
     return m_wavePktReceiveCount;
 }
@@ -120,7 +120,7 @@
 }
 
 int
-WaveBsmStats::GetTxByteCount()
+WaveBsmStats::GetTxByteCount() const
 {
     return m_waveByteSendCount;
 }
@@ -170,13 +170,13 @@
 }
 
 void
-WaveBsmStats::SetLogging(int log)
+WaveBsmStats::SetLogging(bool log)
 {
     m_log = log;
 }
 
-int
-WaveBsmStats::GetLogging()
+bool
+WaveBsmStats::GetLogging() const
 {
     return m_log;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/helper/wave-bsm-stats.h ns-3.38/src/wave/helper/wave-bsm-stats.h
--- ns-3.37/src/wave/helper/wave-bsm-stats.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/helper/wave-bsm-stats.h	2023-03-16 20:54:23.844869400 -0700
@@ -70,7 +70,7 @@
      * \brief Returns the count of transmitted packets
      * \return count of packets transmitted
      */
-    int GetTxPktCount();
+    int GetTxPktCount() const;
 
     /*
      * Note:
@@ -129,7 +129,7 @@
      * \brief Returns the count of packets received
      * \return the count of packets received
      */
-    int GetRxPktCount();
+    int GetRxPktCount() const;
 
     /**
      * \brief Returns the count of expected packets received within range(index)
@@ -190,7 +190,7 @@
      * not include MAC/PHY overhead
      * \return number of bytes of application-data transmitted
      */
-    int GetTxByteCount();
+    int GetTxByteCount() const;
 
     /**
      * \brief Returns the BSM Packet Delivery Ratio (PDR)
@@ -212,26 +212,26 @@
 
     /**
      * \brief Enables/disables logging
-     * \param log
+     * \param log logging state
      */
-    void SetLogging(int log);
+    void SetLogging(bool log);
 
     /**
      * \brief Gets logging state
      * \return logging state
      */
-    int GetLogging();
+    bool GetLogging() const;
 
   private:
     int m_wavePktSendCount;                            ///< packet sent count
     int m_waveByteSendCount;                           ///< byte sent count
     int m_wavePktReceiveCount;                         ///< packet receive count
-    std::vector<int> m_wavePktInCoverageReceiveCounts; ///< packet in ceoverage receive counts
+    std::vector<int> m_wavePktInCoverageReceiveCounts; ///< packet in coverage receive counts
     std::vector<int> m_wavePktExpectedReceiveCounts;   ///< packet expected receive counts
     std::vector<int>
         m_waveTotalPktInCoverageReceiveCounts; ///< total packet in coverage receive counts
     std::vector<int> m_waveTotalPktExpectedReceiveCounts; ///< total packet expected receive counts
-    int m_log;                                            ///< log
+    bool m_log;                                           ///< logging state
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/helper/wave-helper.cc ns-3.38/src/wave/helper/wave-helper.cc
--- ns-3.37/src/wave/helper/wave-helper.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/helper/wave-helper.cc	2023-03-16 20:54:23.844869400 -0700
@@ -91,7 +91,7 @@
                                Ptr<const Packet> p,
                                double snr,
                                WifiMode mode,
-                               enum WifiPreamble preamble)
+                               WifiPreamble preamble)
 {
     NS_LOG_FUNCTION(stream << context << p << snr << mode << preamble);
     *stream->GetStream() << "r " << Simulator::Now().GetSeconds() << " " << context << " " << *p
@@ -111,7 +111,7 @@
                                   Ptr<const Packet> p,
                                   double snr,
                                   WifiMode mode,
-                                  enum WifiPreamble preamble)
+                                  WifiPreamble preamble)
 {
     NS_LOG_FUNCTION(stream << p << snr << mode << preamble);
     *stream->GetStream() << "r " << Simulator::Now().GetSeconds() << " " << *p << std::endl;
@@ -146,8 +146,7 @@
     }
 
     std::vector<Ptr<WifiPhy>> phys = device->GetPhys();
-    NS_ABORT_MSG_IF(phys.size() == 0,
-                    "EnablePcapInternal(): Phy layer in WaveNetDevice must be set");
+    NS_ABORT_MSG_IF(phys.empty(), "EnablePcapInternal(): Phy layer in WaveNetDevice must be set");
 
     PcapHelper pcapHelper;
 
@@ -303,7 +302,7 @@
 void
 WaveHelper::CreateMacForChannel(std::vector<uint32_t> channelNumbers)
 {
-    if (channelNumbers.size() == 0)
+    if (channelNumbers.empty())
     {
         NS_FATAL_ERROR("the WAVE MAC entities is at least one");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/helper/wifi-80211p-helper.cc ns-3.38/src/wave/helper/wifi-80211p-helper.cc
--- ns-3.37/src/wave/helper/wifi-80211p-helper.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/helper/wifi-80211p-helper.cc	2023-03-16 20:54:23.844869400 -0700
@@ -56,7 +56,7 @@
 }
 
 void
-Wifi80211pHelper::SetStandard(enum WifiStandard standard)
+Wifi80211pHelper::SetStandard(WifiStandard standard)
 {
     if (standard == WIFI_STANDARD_80211p)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/helper/wifi-80211p-helper.h ns-3.38/src/wave/helper/wifi-80211p-helper.h
--- ns-3.37/src/wave/helper/wifi-80211p-helper.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/helper/wifi-80211p-helper.h	2023-03-16 20:54:51.628957000 -0700
@@ -58,7 +58,7 @@
      * Users can only configure 802.11p with 10MHz or 5 MHz channel bandwidth.
      * The default 802.11p standard uses 10MHz.
      */
-    void SetStandard(enum WifiStandard standard) override;
+    void SetStandard(WifiStandard standard) override;
 
     /**
      * \param phy the PHY helper to create PHY objects
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/channel-coordinator.h ns-3.38/src/wave/model/channel-coordinator.h
--- ns-3.37/src/wave/model/channel-coordinator.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/channel-coordinator.h	2023-03-16 20:54:23.844869400 -0700
@@ -242,7 +242,7 @@
     Time m_schi; ///< SchInterval
     Time m_gi;   ///< GuardInterval
 
-    /// Listeners typdef
+    /// Listeners typedef
     typedef std::vector<Ptr<ChannelCoordinationListener>> Listeners;
     /// Listeners iterator typedef
     typedef std::vector<Ptr<ChannelCoordinationListener>>::iterator ListenersI;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/channel-scheduler.h ns-3.38/src/wave/model/channel-scheduler.h
--- ns-3.37/src/wave/model/channel-scheduler.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/channel-scheduler.h	2023-03-16 20:54:23.844869400 -0700
@@ -182,7 +182,7 @@
      * \param channelNumber the specified channel number
      * \return  the type of current assigned channel access for the specific channel.
      */
-    virtual enum ChannelAccess GetAssignedAccessType(uint32_t channelNumber) const = 0;
+    virtual ChannelAccess GetAssignedAccessType(uint32_t channelNumber) const = 0;
 
     /**
      * \param schInfo the request information for assigning SCH access.
